package cn.superdesk.uniorder.dao.entity.thirdpart.qchjc.accounting;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class QchjcCustomerBackAccountEntityExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public QchjcCustomerBackAccountEntityExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIsNull() {
            addCriterion("accounting_order_sn is null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIsNotNull() {
            addCriterion("accounting_order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnEqualTo(String value) {
            addCriterion("accounting_order_sn =", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotEqualTo(String value) {
            addCriterion("accounting_order_sn <>", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnGreaterThan(String value) {
            addCriterion("accounting_order_sn >", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("accounting_order_sn >=", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLessThan(String value) {
            addCriterion("accounting_order_sn <", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLessThanOrEqualTo(String value) {
            addCriterion("accounting_order_sn <=", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLike(String value) {
            addCriterion("accounting_order_sn like", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotLike(String value) {
            addCriterion("accounting_order_sn not like", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIn(List<String> values) {
            addCriterion("accounting_order_sn in", values, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotIn(List<String> values) {
            addCriterion("accounting_order_sn not in", values, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnBetween(String value1, String value2) {
            addCriterion("accounting_order_sn between", value1, value2, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotBetween(String value1, String value2) {
            addCriterion("accounting_order_sn not between", value1, value2, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusIsNull() {
            addCriterion("back_account_status is null");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusIsNotNull() {
            addCriterion("back_account_status is not null");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusEqualTo(Integer value) {
            addCriterion("back_account_status =", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusNotEqualTo(Integer value) {
            addCriterion("back_account_status <>", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusGreaterThan(Integer value) {
            addCriterion("back_account_status >", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("back_account_status >=", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusLessThan(Integer value) {
            addCriterion("back_account_status <", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusLessThanOrEqualTo(Integer value) {
            addCriterion("back_account_status <=", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusIn(List<Integer> values) {
            addCriterion("back_account_status in", values, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusNotIn(List<Integer> values) {
            addCriterion("back_account_status not in", values, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusBetween(Integer value1, Integer value2) {
            addCriterion("back_account_status between", value1, value2, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("back_account_status not between", value1, value2, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordIsNull() {
            addCriterion("back_account_mode_record is null");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordIsNotNull() {
            addCriterion("back_account_mode_record is not null");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordEqualTo(Integer value) {
            addCriterion("back_account_mode_record =", value, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordNotEqualTo(Integer value) {
            addCriterion("back_account_mode_record <>", value, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordGreaterThan(Integer value) {
            addCriterion("back_account_mode_record >", value, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordGreaterThanOrEqualTo(Integer value) {
            addCriterion("back_account_mode_record >=", value, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordLessThan(Integer value) {
            addCriterion("back_account_mode_record <", value, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordLessThanOrEqualTo(Integer value) {
            addCriterion("back_account_mode_record <=", value, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordIn(List<Integer> values) {
            addCriterion("back_account_mode_record in", values, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordNotIn(List<Integer> values) {
            addCriterion("back_account_mode_record not in", values, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordBetween(Integer value1, Integer value2) {
            addCriterion("back_account_mode_record between", value1, value2, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountModeRecordNotBetween(Integer value1, Integer value2) {
            addCriterion("back_account_mode_record not between", value1, value2, "backAccountModeRecord");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdIsNull() {
            addCriterion("back_account_user_id is null");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdIsNotNull() {
            addCriterion("back_account_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdEqualTo(String value) {
            addCriterion("back_account_user_id =", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdNotEqualTo(String value) {
            addCriterion("back_account_user_id <>", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdGreaterThan(String value) {
            addCriterion("back_account_user_id >", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("back_account_user_id >=", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdLessThan(String value) {
            addCriterion("back_account_user_id <", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdLessThanOrEqualTo(String value) {
            addCriterion("back_account_user_id <=", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdLike(String value) {
            addCriterion("back_account_user_id like", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdNotLike(String value) {
            addCriterion("back_account_user_id not like", value, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdIn(List<String> values) {
            addCriterion("back_account_user_id in", values, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdNotIn(List<String> values) {
            addCriterion("back_account_user_id not in", values, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdBetween(String value1, String value2) {
            addCriterion("back_account_user_id between", value1, value2, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserIdNotBetween(String value1, String value2) {
            addCriterion("back_account_user_id not between", value1, value2, "backAccountUserId");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameIsNull() {
            addCriterion("back_account_user_name is null");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameIsNotNull() {
            addCriterion("back_account_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameEqualTo(String value) {
            addCriterion("back_account_user_name =", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameNotEqualTo(String value) {
            addCriterion("back_account_user_name <>", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameGreaterThan(String value) {
            addCriterion("back_account_user_name >", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("back_account_user_name >=", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameLessThan(String value) {
            addCriterion("back_account_user_name <", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameLessThanOrEqualTo(String value) {
            addCriterion("back_account_user_name <=", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameLike(String value) {
            addCriterion("back_account_user_name like", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameNotLike(String value) {
            addCriterion("back_account_user_name not like", value, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameIn(List<String> values) {
            addCriterion("back_account_user_name in", values, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameNotIn(List<String> values) {
            addCriterion("back_account_user_name not in", values, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameBetween(String value1, String value2) {
            addCriterion("back_account_user_name between", value1, value2, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountUserNameNotBetween(String value1, String value2) {
            addCriterion("back_account_user_name not between", value1, value2, "backAccountUserName");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeIsNull() {
            addCriterion("back_account_time is null");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeIsNotNull() {
            addCriterion("back_account_time is not null");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeEqualTo(Date value) {
            addCriterion("back_account_time =", value, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeNotEqualTo(Date value) {
            addCriterion("back_account_time <>", value, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeGreaterThan(Date value) {
            addCriterion("back_account_time >", value, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("back_account_time >=", value, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeLessThan(Date value) {
            addCriterion("back_account_time <", value, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeLessThanOrEqualTo(Date value) {
            addCriterion("back_account_time <=", value, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeIn(List<Date> values) {
            addCriterion("back_account_time in", values, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeNotIn(List<Date> values) {
            addCriterion("back_account_time not in", values, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeBetween(Date value1, Date value2) {
            addCriterion("back_account_time between", value1, value2, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andBackAccountTimeNotBetween(Date value1, Date value2) {
            addCriterion("back_account_time not between", value1, value2, "backAccountTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andSyncTimeIsNull() {
            addCriterion("sync_time is null");
            return (Criteria) this;
        }

        public Criteria andSyncTimeIsNotNull() {
            addCriterion("sync_time is not null");
            return (Criteria) this;
        }

        public Criteria andSyncTimeEqualTo(Date value) {
            addCriterion("sync_time =", value, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeNotEqualTo(Date value) {
            addCriterion("sync_time <>", value, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeGreaterThan(Date value) {
            addCriterion("sync_time >", value, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("sync_time >=", value, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeLessThan(Date value) {
            addCriterion("sync_time <", value, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeLessThanOrEqualTo(Date value) {
            addCriterion("sync_time <=", value, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeIn(List<Date> values) {
            addCriterion("sync_time in", values, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeNotIn(List<Date> values) {
            addCriterion("sync_time not in", values, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeBetween(Date value1, Date value2) {
            addCriterion("sync_time between", value1, value2, "syncTime");
            return (Criteria) this;
        }

        public Criteria andSyncTimeNotBetween(Date value1, Date value2) {
            addCriterion("sync_time not between", value1, value2, "syncTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}